function [Numc,Denc,kc,strc,Tc]=ltf(gi)
%LTF      Loads a transfer function (aux for TFI).
%   [Num,Den,k,str]=LTF('gi') loads variables Num,Den,k,str from gi.mat.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

aa=1; Tc=0; strc='s';
eval(['load ',gi],'aa=2;')
if aa==2
 fprintf(['\n loading error (',gi,')\n'])
end
if strc=='z', T=lsamp; end
if (strc=='z')&(Tc~=0)&(Tc~=T)
 fprintf(['\n **** warning: the sampling time of ',gi,' is %.4g sec\n'],Tc)
end
if ~exist('Numc')
 Numc=NaN; Denc=NaN; kc=NaN; strc='s'; Tc=0;
end
% --- last line of ltf ---
