function tfg1(arg1,arg2,arg3,arg4)
%TFG1	  Transfer function display (aux for TFI).
%   TFG1('gi') shows transfer function gi.
%   If gi is a parametric transfer functions, both the numeric and
%   the parametric form are shown.
%   **** MODIFIED FOR THE ITALIAN VERSION OF TFI

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

if nargin==0
 flg=0;
 while flg==0
  gi=input('   specificare la funzione di trasferimento : ','s');
  if ~isempty(gi)
   if ~exist([gi,'.mat'])
    disp([' **** errore: ',gi,'.mat non esiste'])
   else
    flg=1;
   end
  end
 end
else
 if ~exist([arg1,'.mat'])
  disp([' **** errore: ',arg1,'.mat non esiste']), return
 else
  gi=arg1;
 end
end
%
eval(['load ',gi])
%
if ~exist('parkc')
 rob=0; a=1;
else
 rob=1; a=2;
 strk=parkc;
 prN=size(parNc); prD=size(parDc);
 prN1=','*ones(prN(1),1); prD1=','*ones(prD(1),1);
 strnum=[prN1,parNc,prN1];
 strden=[prD1,parDc,prD1];
end
%
Num=Numc; Den=Denc; k=kc; str=strc;
%
for indx=1:a
 if a==2 & indx==1 & rob==1, fprintf('\n   FORMA NUMERICA NOMINALE :\n'), end
 if (indx==2 | a==1) & rob==1, fprintf('\n   FORMA PARAMETRICA :\n'), end
 fprintf('\n')
 [egv1,mul1,egv2,mul2,k]=ordg(Num,Den,k);
 if rob==1 & indx==a & ~strcmp(sprintf('%.4g',k),strk)
  k=strk; kl=length(k);
 else
  kl=length(sprintf('%.4g',k));
 end
 gl=length(gi)+3;
 for hh=1:gl, fprintf(' '), end
 i=4; nzpl=[]; vnil=[]; nz1=[]; nz2=[];
%
 len=74; % max. length of expression
%
 for i=4:-1:1
  index=0; nzpl1=0;
  if (i==2)|(i==4)
   e=egv1; m=mul1; nil=kl;
   if rob==1, e1=strnum; end
  elseif (i==1)|(i==3)
   e=egv2; m=mul2; nil=0;
   if rob==1, e1=strden; end
  end
  if i==2
   if rob==1 & indx==a & ~strcmp(sprintf('%.4g',k),strk)
    fprintf(k)
   else
    fprintf('%.4g',k)
   end
  end
  le=size(e);
  if (i==3)|((i==4)&(le(2)~=1))
   for nr=1:le(1)
    g=e(nr,:);q=find(g~=0);
    if rob==1, g1=e1(nr,:);q1=find(g1==','); end
    kk=le(2); ncm=length(sprintf('%.4g',m(nr)));
    while kk~=0
     if abs(g(le(2)+1-kk))>0
      if rob==1
       gg1=deblank(g1(q1(le(2)+1-kk)+1:q1(le(2)+2-kk)-1));
      else
       gg1='$$$';
      end
      nt=length(sprintf('%.4g',abs(g(le(2)+1-kk))));
      nc=length(sprintf('%.4g',kk-1));
      if (le(2)+1-kk)==q(1)
       if (nr~=1)|((nr==1)&(i==4)), nil=nil+1; end
       if length(q)>1, nil=nil+1; end
      end
      if ((le(2)+1-kk)~=q(1))|(((le(2)+1-kk)==q(1))&(g(le(2)+1-kk)<0))
       nil=nil+3;
      end
      if rob==1 & indx==a & ~(strcmp(sprintf('%.4g',g(le(2)+1-kk)),gg1))
       nil=nil+length(sprintf(gg1));
      else
       if (abs(g(le(2)+1-kk))~=1)|((abs(g(le(2)+1-kk))==1)&(kk-1==0))
	nil=nil+nt;
       end
      end
      if kk-1>0
       if abs(g(le(2)+1-kk))~=1
	nil=nil+2;
       else
	if rob==1 & indx==a & ~(strcmp(sprintf('%.4g',g(le(2)+1-kk)),gg1))
	 nil=nil+1;
	end
	nil=nil+1;
       end
      end
      if (kk==1)&(nr==le(1)), inc=1; else, inc=0; end
      if kk-1>1, nil=nil+1+nc; end
      nzpl1=[nzpl1,nil];
      if nil>(len-gl-inc)
       nil=nzpl1(length(nzpl1))-nzpl1(length(nzpl1)-1)-1;
       nzpl=[nzpl,nzpl1(length(nzpl1)-1)];
       vnil=[vnil,diff(nzpl1)]; nzpl1=nil;
      end
     end
     kk=kk-1;
    end
    if length(q)>1, nil=nil+1; end
    if (m(nr)>1)&(length(find(g~=0))>0), nil=nil+1+ncm; end
    nzpl1=[nzpl1,nil]; nzpl=[nzpl,nil];
   end
   if i==4
    vnil1=[vnil,diff(nzpl1)]; xx=0; vnil=[];
    for kk=1:length(vnil1)
     if (xx+vnil1(kk))<=max(nzpl)
      xx=xx+vnil1(kk);
     else
      nz1=[nz1,xx]; xx=vnil1(kk)-1;
     end
    end
    nz1=[nz1,xx];
   else
    vnil2=[vnil,diff(nzpl1)]; xx=0;
    for kk=1:length(vnil2)
     if (xx+vnil2(kk))<=max(nzpl)
      xx=xx+vnil2(kk);
     else
      nz2=[nz2,xx]; xx=vnil2(kk)-1;
     end
    end
    nz2=[nz2,xx];
   end
  elseif (i==1)|((i==2)&(le(2)~=1))
   if i==2, nz=nz1; else, nz=nz2; end
   index=index+1;
   for nr=1:le(1)
    g=e(nr,:);q=find(g~=0);
    if rob==1, g1=e1(nr,:);q1=find(g1==','); end
    kk=le(2); ncm=length(sprintf('%.4g',m(nr)));
    while kk~=0
     len=nz(index);
     if abs(g(le(2)+1-kk))>0
      if rob==1
       gg1=deblank(g1(q1(le(2)+1-kk)+1:q1(le(2)+2-kk)-1));
      else
       gg1='$$$';
      end
      nt=length(sprintf('%.4g',abs(g(le(2)+1-kk))));
      nc=length(sprintf('%.4g',kk-1));
      rop=strcmp(sprintf('%.4g',g(le(2)+1-kk)),gg1); sgn=' + ';
      if (rob==0)|rop|(indx==1)
       if g(le(2)+1-kk)>0
	sgn=(' + ');
       elseif g(le(2)+1-kk)<0
	sgn=(' - ');
       end
      end
      if (le(2)+1-kk)==q(1)
       if (nr~=1)|((nr==1)&(i==2)), fprintf(' '), nil=nil+1; end
       if length(q)>1, fprintf('('), nil=nil+1; end
      end
      if ((le(2)+1-kk)~=q(1))|(((le(2)+1-kk)==q(1))&(g(le(2)+1-kk)<0))
       fprintf(sgn), nil=nil+3;
      end
      if rob==1 & indx==a & ~rop
       fprintf(gg1), nil=nil+length(sprintf(gg1));
      else
       if (abs(g(le(2)+1-kk))~=1)|((abs(g(le(2)+1-kk))==1)&(kk-1==0))
	fprintf('%.4g',abs(g(le(2)+1-kk))), nil=nil+nt;
       end
      end
      if kk-1>0
       if abs(g(le(2)+1-kk))~=1
	fprintf('*'), fprintf(str), nil=nil+2;
       else
	if rob==1 & indx==a & ~(strcmp(sprintf('%.4g',g(le(2)+1-kk)),gg1))
	 fprintf('*')
	end
	fprintf(str), nil=nil+1;
       end
      end
      if kk-1>1, fprintf('^%.4g',kk-1), nil=nil+1+nc; end
      if (nil>=len)&(index<length(nz))
       index=index+1; nil=-1; fprintf('\n')
       for hh=1:gl-1, fprintf(' '), end
       if kk==1, fprintf(' '), end
      end
     end
     kk=kk-1;
    end
    if length(q)>1, fprintf(')'), nil=nil+1; end
    if (m(nr)>1)&(length(find(g~=0))>0)
     fprintf('^%.4g',m(nr)), nil=nil+1+ncm;
    end
    if (nil>=len)&(nr~=le(1))&(index<length(nz))
     index=index+1; nil=-1; fprintf('\n'),
     for hh=1:gl-1, fprintf(' '), end
    end
   end
  end
  if i==2
   fprintf('\n'), fprintf(gi), fprintf(' = ')
   for in=1:max([nz1,nz2,kl]), fprintf(setstr(173)), end
   fprintf('\n')
   for hh=1:gl, fprintf(' '), end
  end
 end
 fprintf('\n')
end
if rob==1
 sp=size(intvparc); mm=0;
 for i=1:sp(1)
  lsv=length(sprintf('%.4g',intvparc(i,3)));
  if mm<lsv, mm=lsv; end
 end
 for i=1:sp(1)
  fprintf('\n   ')
  fprintf(matparc(i,:))
  lsv=length(sprintf('%.4g',intvparc(i,3)));
  fprintf(': valore nominale %.4g',intvparc(i,3))
  for j=1:mm-lsv, fprintf(' '), end
  fprintf(', intervallo [%.4g, %.4g]',intvparc(i,1),intvparc(i,2))
 end
 fprintf('\n')
end
% --- last line of tfg1 ---
