function makeleg(arg1,arg2,arg3,arg4)
%MAKELEG  Creates or cleans a legend in the last figure (TFI).

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

global HALEG FIGLEG LABLEG SUBPLEG

if isempty(FIGLEG), FIGLEG=0; end
if ~exist('legend.m'), return, end
if FIGLEG==0
 disp(' '), disp(' **** legend is not available in this case'), return
end
if FIGLEG~=gcf
 ms1=['\n **** error: you must select figure ',int2str(FIGLEG),'\n'];
 fprintf(ms1), return
end
xx=get(gca,'XTickLabels'); yy=get(gca,'YTickLabels');
if isempty(xx)&isempty(yy), delete(gca), end
ordf(3) % legend off
if SUBPLEG==1, subplot(2,1,1), end
eval(['fl=legend(HALEG,',LABLEG,'); axes(fl)'],'aa=1;')
if nargin==0, pause, ordf(1), end
% --- last line of makeleg ---
