function v2n=ordvv(v1,v2)
%   Sorts complex numbers by minimum difference (aux for TFI).
%   v2n=ORDVV(v1,v2) sorts the components of v2 in v2n to make
%   max(abs(v2n-v1)) minimum.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

nn=length(v2);
[zzz,iind]=sort(abs(v1));
zznc=v2; zznd=v2;
for kkw=iind';
 zzvc=v1(kkw)*ones(nn,1);
 ttr=zznc(iind)-zzvc(iind);
 [zx1,kin]=min(abs(ttr));
 kin=iind(kin);
 zznd(kkw)=zznc(kin);
 iind=iind(find(iind~=kin));
end
v2n=zznd;
% --- last line of ordvv ---
