function defactf(arg1,arg2,arg3,arg4)
%DEFACTF  Defattorizzazione di funzione di trasferimento (TFI).
%    DEFACTF,gi,gj - da TFI [DEFACTF('gi','gj') - da Matlab] memorizza in
%    gj la forma polinomiale di gi.
%    Se DEFACTF viene chiamato senza alcun argomento, le f.d.t. gi e gj
%    possono essere specificate in interattivo.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

if nargin==0
 gi=input('   funzione di trasferimento gi (ingresso) : ','s');
 if isempty(gi), return, end
 if gi=='0', return, end
 if ~exist([gi,'.mat'])
  disp([' **** errore: ',gi,'.mat non esiste']), return
 end
 gj=input('   funzione di trasferimento gj (uscita) : ','s');
 if isempty(gj), return, end
 if gj=='0', return, end
elseif nargin>=2
 if ~exist([arg1,'.mat'])
  disp([' **** errore: ',arg1,'.mat non esiste']), return
 else
  gi=arg1; gj=arg2;
 end
else
 disp(' **** errore: numero di argomenti non sufficiente'), return
end
[num,den,str]=exportf(gi,1); if isempty(den), return, end
tfg(gi)
if str=='s'
 aa=importf(num,den,gj);
else
 aa=importf(num,den,gj,1);
end
if aa==1, tfg(gj), end
% --- last line of defactf ---
